; nasm
    bits 16
    org 0x0000

    jmp readsec
    jmp wrtsec

cyl:
    db 4
head:
    db 9
sect:
    db 5
segsave:
    dw 0

wrtsec:
    push ax
    push bx
    push cx
    push dx
    push si
    push es
    push ds

    mov ax,0x9e00
    mov ds, ax
    mov ax,0x9e00
    mov es, ax

; seek
    mov ah,10h
    mov cl,BYTE[cyl]
    int 1bh

    mov dx,buf0
    mov bp,dx
    mov ah,75h
    mov al,90h
    mov bx,1024
    mov ch,3    ; len of sector
    mov cl,BYTE[cyl]    ; cylin
    mov dh,BYTE[head]    ; head
    mov dl,BYTE[sect]    ;sector
    int 1bh

    mov [rt0],BYTE 2
    jnc noer_w
    mov [rt0],BYTE 4
noer_w:
    mov BYTE[sta0],ah
    
    pop ds
    pop es
    pop si
    pop dx
    pop cx
    pop bx
    pop ax

    iret

readsec:
    push ax
    push bx
    push cx
    push dx
    push si
    push es
    push ds

    mov ax,0x9e00
    mov ds, ax
    mov ax,0x9e00
    mov es, ax


; seek
    mov ah,10h
    mov cl,BYTE[cyl]
    int 1bh

    mov dx,buf0
    mov bp,dx
    mov ah,76h
    mov al,90h
    mov bx,1024
    mov ch,3    ; len of sector
    mov cl,BYTE[cyl]    ; cylin
    mov dh,BYTE[head]    ; head
    mov dl,BYTE[sect]    ; sector
    int 1bh

    mov [rt0],BYTE 2
    jnc noer_r
    mov [rt0],BYTE 4
noer_r:
    mov BYTE[sta0],ah
    

    pop ds
    pop es
    pop si
    pop dx
    pop cx
    pop bx
    pop ax

    iret

rt0:
    db 99h
sta0:
    db 44h

    align 2
buf0:
    db 22h
